﻿KKBK_VERSION = "0.1"
KKBK_NAME_VERSION = "KKBK "..KKBK_VERSION
kkbk_class = {}
MY_CLASS = ""
MY_CLASS_LOCALIZED = ""
DEBUG = false

ui_elements = {
    player_names = {},
    checkbox = {}
}
current_page = ""
pages = {}
is_raid_init = false

-- we suppose max 10 player from the same class
MAX_PLAYERS = 10
-- number of groups
MAX_GROUPS = 8

-- buff for classes
BUFFS = {
    PRIEST = {
        { longName = FORTITUDE[1], shortName = FORTITUDE[2]},
        { longName = SPIRIT[1], shortName = SPIRIT[2]},
        { longName = SHADOW[1], shortName = SHADOW[2]}
    },
    DRUID = {
        { longName = MARKOFWILD[1], shortName = MARKOFWILD[2]},
        { longName = THORNS[1], shortName = THORNS[2]},
    },
    MAGE = {
        { longName = INTELLECT[1], shortName = INTELLECT[2]},
    },
}

function kkbk_onLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	SLASH_KKBK1 = "/kkbk"
	SlashCmdList["KKBK"] = kkbk_toggleFrame
	DEFAULT_CHAT_FRAME:AddMessage("KikiBufKoi : "..KKBK_VERSION.." loaded.")
	playerClass, englishClass = UnitClass("player")
	MY_CLASS = englishClass;
    if DEBUG then
        MY_CLASS = "PRIEST"
    end
	MY_CLASS_LOCALIZED = playerClass

	kkbk_InitUI();
    
	this:RegisterEvent("VARIABLES_LOADED")
end

--RAID_ROSTER_UPDATE

function kkbk_InitUI()    
    local group_x = 10
    local group_y = -5
    local right_pos = 100
    local top_pos = -25
    
    -- place group labels
    local group = CreateFrame("Frame", "group_names", kkbk_MainFramePanel2, "kkbk_label_group_template");
    group:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, group_y);
    getglobal("group_namesText"):SetText(GROUP)
    group:Show()
    
    local y_line = 4
    local x_line = 2
    
    for i=1, MAX_GROUPS do
        local label = CreateFrame("Frame", "group_label_"..i, kkbk_MainFramePanel2, "kkbk_label_group_num_template");
        label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , right_pos + (group_x * (i * x_line)), group_y);
        getglobal("group_label_"..i.."Text"):SetText(""..i)
        label:Show()
    end
    
    -- place players
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i] = CreateFrame("Frame", "player_label_"..i, kkbk_MainFramePanel2, "kkbk_label_player_template");
        local label = ui_elements["player_names"][i]
        label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, top_pos + (group_y * (i * y_line)));
        getglobal("player_label_"..i.."Text"):SetText("player"..i)
        label:Hide()
    end
    
    -- place checkboxes
    for i=1, MAX_PLAYERS do
        ui_elements["checkbox"][i] = {}
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii] = CreateFrame("CheckButton", "checkbox_"..i.."_"..ii, kkbk_MainFramePanel2, "kkbk_checkbutton_template");
            local label = ui_elements["checkbox"][i][ii]
            local my_x = right_pos + (group_x * (ii * x_line))
            local my_y = top_pos + (group_y * (i * y_line))
            label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , my_x, my_y)
            label:Hide()
            
            local vi = i
            local vii = ii
            ui_elements["checkbox"][i][ii] = label
            label:SetScript("OnClick", function() kkbk_checkboxClic(vi, vii) end)
        end
    end
    
    for key, value in BUFFS[MY_CLASS] do
        local button = CreateFrame("Button", "buff_btn_"..key, kkbk_MainFramePanel3, "kkbk_buff_btn_template")
        button:SetPoint("CENTER", "kkbk_MainFramePanel3", "TOP" , 0, 0 - (key * y_line * 6))
        local string = getglobal("buff_btn_"..key.."Text");
        kkbk_debug(key .. " " .. " " .. value.longName .. " " .. value.shortName)
        
        local shortName = value.shortName
        local longName = value.longName

        button:SetScript("OnClick", function() kkbk_page(shortName, longName) end);
        button:Show()
        button:SetText(value.shortName)
        
        if key == 1 then
            kkbk_page(shortName, longName)
        end
    end
end

function kkbk_page(shortName, longName)
    kkbk_debug("changing page : " .. shortName);
    current_page = shortName
    if not pages[current_page] then
        pages[current_page] = {}
        for i=1, MAX_PLAYERS do
            pages[current_page][i] = {}
            for ii=1, MAX_GROUPS do
                pages[current_page][i][ii] = nil
                ui_elements["checkbox"][i][ii]:SetChecked(nil)
            end
        end
    else
        for i=1, MAX_PLAYERS do
            for ii=1, MAX_GROUPS do
                ui_elements["checkbox"][i][ii]:SetChecked(pages[current_page][i][ii])
            end
        end
    end
    kkbk_buff_name:SetText(longName)
end

function kkbk_checkboxClic(i, ii)
    pages[current_page][i][ii] = true
    for o=1, MAX_PLAYERS do
        if o ~= i and ui_elements["checkbox"][o][ii]:IsVisible() then
            ui_elements["checkbox"][o][ii]:SetChecked(nil)
            pages[current_page][o][ii] = nil
        end
    end
end

function kkbk_toggleFrame()
	if (kkbk_MainFrame:IsVisible()) then
		kkbk_MainFrame:Hide()
	else
		kkbk_MainFrame:Show()
	end	
end

function kkbk_sendToChan()    
    local strg = ""
    for page, arr in pages do
        for player, groups in arr do
            local group_to_buff = ""
            for group, buff in groups do
                if buff ~= nil then
                    if group_to_buff ~= "" then
                        group_to_buff = group_to_buff .. " "
                    end
                        group_to_buff = group_to_buff .. group
                end
            end
            if group_to_buff ~= "" then
                name = kkbk_class[player]
		kkbk_debug(name)
                --kkbk_debug(name .. " buff " .. page .. " sur " .. group_to_buff)
                strg = strg .. " # " .. name .. " : " .. page .. " [" .. group_to_buff .. "]"
            end
        end
    end
    if strg ~= "" then
        --kkbk_debug("sending to "..kkbk_chan:GetText() .. " " .. strg)
        id, name = GetChannelName(kkbk_chan:GetText())
        SendChatMessage(strg, "CHANNEL", nil, id);
    end
end

function kkbk_resetEvent()
    kkbk_reset()
    kkbk_initRaid()
    kkbk_page(current_page, kkbk_getLongName(current_page))
end

function kkbk_getLongName(short)
    for key, value in BUFFS[MY_CLASS] do
        if value.shortName == short then
            return value.longName
        end
    end
    return ""
end

function kkbk_reset()
    is_raid_init = false
    kkbk_class = {}
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i]:Hide()
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii]:Hide()
            ui_elements["checkbox"][i][ii]:SetChecked(nil)
            pages = {}
        end
    end
end

function kkbk_initRaid()    
    if is_raid_init then return end

    kkbk_debug("init raid");
    
    is_raid_init = true
    
    -- getting all players from selected class
    if DEBUG then
        kkbk_class = { "Pierre", "Paul", "Jacques", "Jean", "Marc", "Pascal"}
    else
	local o=1
        for i=1, GetNumRaidMembers() do
            name = GetRaidRosterInfo(i)
            if name ~= nil then
                playerClass, englishClass = UnitClass("raid"..i);
                if englishClass ~= nil and playerClass ~= nil then
                    if englishClass == MY_CLASS then
                        kkbk_class[o] = name
                        kkbk_debug("add "..name.." to " ..playerClass)
			o = o + 1
                    end
                end
            end
        end
    end
    
    table.sort(kkbk_class)
    
    -- ok, now we can draw the window
    local i = 1
    for k, v in kkbk_class do
        getglobal(ui_elements["player_names"][i]:GetName().."Text"):SetText(v)
        ui_elements["player_names"][i]:Show()
        for ii = 1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii]:Show()
        end
        i = i + 1
    end
end

function kkbk_debug(msg) 
    if DEBUG then
        DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end